#include<sys/socket.h> 
#include<netinet/in.h>
#include<sys/types.h>
#include"auth.h"
#include"xdr.h"
#include"xprt.h"
#include"msg_prot.h"
#include"rpc_msg.h"

#define UDPMSGSIZE      8800    /* rpc imposed limit on udp msg size */

unsigned int prepareXDR(char * buff, XDR * xdr)
{	
        int xid, slen;
        int sent;
        xdr->x_base = (char *)malloc( UDPMSGSIZE);
        xdr->x_private = xdr->x_base;
        xid = (u_long)ntohl((u_long)((struct rpc_msg*) buff)->rm_xid);
        * (uint32_t *) xdr->x_private = htonl(xid);
        xdr->x_private = xdr->x_private + 4;
        *(int *)xdr->x_private =  htonl(REPLY);
        xdr->x_private = xdr->x_private + 4;
        *(int *)xdr->x_private =  htonl(MSG_ACCEPTED);
        xdr->x_private = xdr->x_private + 4;
        *(int *)xdr->x_private =  htonl(0); /* opaque_auth.oa_flavour*/
        xdr->x_private = xdr->x_private + 4;
        *(int *)xdr->x_private =  htonl(0); /* opaque_auth.oa_length */
        xdr->x_private = xdr->x_private + 4;
         *(int *)xdr->x_private =  htonl(SUCCESS);
        xdr->x_private = xdr->x_private + 4;
	slen = xdr->x_private - xdr->x_base;
	return slen;
}
